use super::*;

/// Visitor used in [`Mentionable::points_typed`].
pub trait TakesPoints<'a, Ctx: Context<'a>> {
    /// Visit a [Point].
    fn take<A: Mentionable<'a, Ctx>>(&mut self, point: &Point<'a, Ctx, A>);
}

impl<'a, Ctx: Context<'a>> TakesPoints<'a, Ctx> for Vec<u8> {
    /// The only natural implementation, as used in [`Mentionable::topology`].
    fn take<A: Mentionable<'a, Ctx>>(&mut self, point: &Point<'a, Ctx, A>) {
        self.extend(point.point)
    }
}
